// =========================== Atmega16 CPU ׽Ʈ α׷ ===================
//  CPU : ATmega16-16M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : Avrstudio 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#define	__STDIO_FDEVOPEN_COMPAT_12

// ⺻ 
// === AVR includes ===
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
//#include <float.h>
//#include <math.h>

#include "avr/io.h"
#include "avr/interrupt.h"

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ

// Լ 
void main_menu_disp(void);					//  ޴ ǥ
void cpu_ioport_output(void);				// CPU PORT I/O ׽Ʈ
void timer0_test(void);						// TIMER0 TEST
void timer1_test(void);						// TIMER1 TEST
void timer2_test(void);						// TIMER2 TEST
void exint_test(void);						// EXINT0,1 TEST
void ad_polling_test(void);					// A/D   TEST
unsigned int ad_read(unsigned char adc_input);// A/D  ( )
void ad_interrupt_test(void);				// A/D ͷƮ  TEST
void ad_start(unsigned char adc_input);		// AD  (ͷƮ ) 

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();							// cpuʱȭ
	main_menu_disp();						//  ޴ ǥ
	while(1){								// Place your code here
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
			else if(com1_rx_data == '2') timer0_test();// TIMER0 TEST
			else if(com1_rx_data == '3') timer1_test();// TIMER1 TEST
			else if(com1_rx_data == '4') timer2_test();// TIMER2 TEST
			else if(com1_rx_data == '5') exint_test();// EXINT0,1 TEST
			else if(com1_rx_data == '6') ad_polling_test();// A/D POLLING TEST
			else if(com1_rx_data == '7') ad_interrupt_test();// A/D POLLING TEST
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
	return 0;
}

// =====================================  ޴ ǥ =======================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("========= MAIN MENU ======\r\n");
	printf("- 1 : CPU I/O PORT TEST   \r\n");
	printf("- 2 : TIMER0 TEST         \r\n");
	printf("- 3 : TIMER1 TEST         \r\n");
	printf("- 4 : TIMER2 TEST         \r\n");
	printf("- 5 : EXINT0,1 TEST       \r\n");
	printf("- 6 : A/D POLLING   TEST  \r\n");
	printf("- 7 : A/D INTERRUPT TEST  \r\n");
	printf("--------- CPUPLAZA -------\r\n");
}

// ============================== CPU_IO TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void cpu_ioport_output(void)
{
int out_cnt,exit_flg = 0;

	printf("====== CPU I/O PORT TEST =====\r\n");
	printf("- 0  : TOP menu               \r\n");
	printf("------------------------------\r\n");

// CPU PORT   
// PORTA[0..7] : OUT 
	PORTA=0xff;								// Ʈ  reg
	DDRA=0xff;								// Ʈ  reg(0Է,1)
// CPU PORT   
// PORTB[0..7] : OUT 
	PORTB=0xff;								// Ʈ  reg
	DDRB=0xff;								// Ʈ  reg(0Է,1)
// PORTC[0..5] : OUT 
	PORTC=0xff;								// Ʈ  reg
	DDRC=0xff;								// Ʈ  reg(0Է,1)
// PORTD[2..7] : OUT 
	PORTD=0xfc;								// Ʈ  reg
	DDRD=0xfc;								// Ʈ  reg(0Է,1)

// LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
	TCCR0 = 0x05;							// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;								// 255-156 = 99	
	OCR0 = 0x00;
	TIMSK |= 0x01;							// TIMER0 ͷƮ 㰡

	timer0_cnt = 0;							// TIMER0 ͷƮ ī Ŭ
	out_cnt = 0;
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 50){				// 500ms  
			if(out_cnt >= 0 && out_cnt < 8) PORTA = ~(1 << out_cnt);// PORTA (ش Ʈ 0)
			else if(out_cnt >= 8 && out_cnt < 16){	// PORTB 
				if(out_cnt == 8) PORTA = 0xff;// PORTA CLEAR
				PORTB = ~(1 << (out_cnt-8));// PORTB (ش Ʈ 0)
			}
			else if(out_cnt >= 16 && out_cnt < 24){	// PORT C 
				if(out_cnt == 16) PORTB = 0xff;// PORTB CLEAR
				PORTC = ~(1 << (out_cnt-16));// PORTC (ش Ʈ 0)
			}
			else if(out_cnt >= 24 && out_cnt < 30){	// PORTD 
				if(out_cnt == 24) PORTC = 0xff;// PORTC CLEAR
				PORTD = ~(4 << (out_cnt-24));// PORTD (ش Ʈ 0)
			}
			out_cnt++;						//  ġ ī 
			if(out_cnt >= 32) out_cnt = 0;	//  ġ ʰ ˻
			if(out_cnt == 0){				//  ü ʱȭ
				PORTA = 0xff;
				PORTB = 0xff;
				PORTC = 0xff;
				PORTD = 0xfc;
			}
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	TCCR0 = 0x00;
	TCNT0 = 0;	
	OCR0 = 0x00;
	TIMSK &= 0xfe;							// TIMER0 ͷƮ 

// CPU PORT ʱⰪ  
// PORTA
	PORTA=0x00;							// Ʈ  reg
	DDRA=0x00;							// Ʈ  reg(0Է,1)
// PORTB
	PORTB=0x00;							// Ʈ  reg
	DDRB=0x00;							// Ʈ  reg(0Է,1)
// PORTC
	PORTC=0x00;							// Ʈ  reg
	DDRC=0x00;							// Ʈ  reg(0Է,1)
// PORTD
	PORTD=0x00;							// Ʈ  reg
	DDRD=0x00;							// Ʈ  reg(0Է,1)
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER0 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer0_test(void)
{
int exit_flg = 0;

	printf("=========== TIMER0 TEST ======\r\n");
	printf("- 0  : TOP menu               \r\n");
	printf("------------------------------\r\n");

// Timer/Counter0 (Overflow)
	TCCR0 = 0x05;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;							// 255-156 = 99	
	OCR0 = 0x00;
	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
	
	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 100){			// 999.84ms üũ
			printf("TIMER0 Overflow Interrupt\r\n");
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	TCCR0 = 0x00;
	TCNT0 = 0;	
	OCR0 = 0x00;
	TIMSK &= 0xfe;						// TIMER0 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER1 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer1_test(void)
{
int exit_flg = 0;

	printf("========== TIMER1 TEST =======\r\n");
	printf("- 0  : TOP menu               \r\n");
	printf("------------------------------\r\n");

// Timer/Counter1 (Overflow)
	TCCR1A = 0x00;
	TCCR1B = 0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	TCNT1 = 63035;						// 65535 - 2500 = 63035
	OCR1AH = 0x00;
	OCR1AL = 0x00;
	OCR1BH = 0x00;
	OCR1BL = 0x00;	
	TIMSK |= 0x04;						// TIMER1 ͷƮ 㰡

	timer1_cnt = 0;						// TIMER1 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){				// COM1  ˻
		if(com1_rx_eflg){
			if(com1_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer1_cnt >= 100){				// 1s üũ
			printf("TIMER1 Overflow Interrupt\r\n");
			timer1_cnt = 0;
		}
	}

// Timer/Counter1 
	TCCR1A = 0x00;
	TCCR1B = 0x00;
	TCNT1H = 0x00;
	TCNT1L = 0x00;
	OCR1AH = 0x00;
	OCR1AL = 0x00;
	OCR1BH = 0x00;
	OCR1BL = 0x00;	
	TIMSK &= 0xfb;						// TIMER1 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER2 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer2_test(void)
{
int exit_flg = 0;

	printf("========== TIMER2 TEST =======\r\n");
	printf("- 0  : TOP menu               \r\n");
	printf("------------------------------\r\n");

// Timer/Counter2 (Overflow)
	ASSR = 0x00;
	TCCR2 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT2 = 99;							// 255-156 = 99
	OCR2 = 0x00;
	TIMSK |= 0x40;						// TIMER2 ͷƮ 㰡

	timer2_cnt = 0;						// TIMER2 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com1_rx_data);	// ݼ
			com1_rx_eflg = 0;
		}
		if(timer2_cnt >= 100){			// 999.84ms üũ
			printf("TIMER2 Overflow Interrupt\r\n");
			timer2_cnt = 0;
		}
	}

// Timer/Counter2 
	ASSR = 0x00;
	TCCR2 = 0x00;
	TCNT2 = 0;
	OCR2 = 0x00;
	TIMSK &= 0xbf;						// TIMER2 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== EXINT0,1 TEST ===============================
// [μ]: void
// ----------------------------------------------------------------------------
void exint_test(void)
{
int exit_flg = 0;

	printf("======== EXINT0,1 TEST =======\r\n");
	printf("- 0  : TOP menu               \r\n");
	printf("-      INT0-2 Falling Edge    \r\n");
	printf("------------------------------\r\n");

// External Interrupt(s) 
// INT0 Mode: Falling Edge
// INT1 Mode: Falling Edge
// INT2 Mode: Falling Edge
	GICR|=0xE0;
	MCUCR=0x0A;
	MCUCSR=0x00;
	GIFR=0xE0;

	exint0_flg = exint1_flg = exint2_flg = 0;// EXINT0,1 ͷƮ ÷ Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(exint0_flg){					// EXINT0 ͷƮ ÷ üũ
			printf("EXINT0 Interrupt\r\n");
			exint0_flg = 0;
		}
		if(exint1_flg){					// EXINT1 ͷƮ ÷ üũ
			printf("EXINT1 Interrupt\r\n");
			exint1_flg = 0;
		}
		if(exint2_flg){					// EXINT2 ͷƮ ÷ üũ
			printf("EXINT2 Interrupt\r\n");
			exint2_flg = 0;
		}
	}

// External Interrupt(s) 
	GICR&=0x1f;
	MCUCR=0x00;
	MCUCSR=0x00;
	GIFR=0x00;
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: void
// ----------------------------------------------------------------------------
void ad_polling_test(void)
{
unsigned datau;
int exit_flg = 0;

	printf("====== A/D POLLING TEST ======\r\n");
	printf("- 0  : TOP menu               \r\n");
	printf("- 1-8: CH0-7 READ             \r\n");
	printf("------------------------------\r\n");

// ADC initialization 
	ADMUX = 0x00;						//   AREF
	ADCSRA = 0x87;						// ADC Enable,ADC Clock 125.000Khz
	SFIOR &= 0xEF;
	
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1') datau = ad_read(0);// CH0 
			else if(com1_rx_data == '2') datau = ad_read(1);// CH1 
			else if(com1_rx_data == '3') datau = ad_read(2);// CH2 
			else if(com1_rx_data == '4') datau = ad_read(3);// CH3 
			else if(com1_rx_data == '5') datau = ad_read(4);// CH4 
			else if(com1_rx_data == '6') datau = ad_read(5);// CH5 
			else if(com1_rx_data == '7') datau = ad_read(6);// CH6 
			else if(com1_rx_data == '8') datau = ad_read(7);// CH7 
			else putchar(com1_rx_data);	// ݼ
			// A/D  ǥ
			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("ADC CH%d > %d\r\n",(com1_rx_data&0x0f)-1,datau);
			com1_rx_eflg = 0;
		}
	}

// ADC initialization 
	ADMUX = 0x00;
	ADCSRA = 0x00;
	SFIOR &= 0xEF;
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: unsigned char adc_input
// ITEM1 : AD CH(0-7)
// []: A/D 10bit
// ----------------------------------------------------------------------------
unsigned int ad_read(unsigned char adc_input)
{
	ADMUX = adc_input;					// ADREF(0) + CH
	ADCSRA |= 0x40;						// AD conversion 
	while((ADCSRA & 0x10) == 0);				//  Ϸ 
	ADCSRA |= 0x10;						// AD ÷ Ŭ
	return ADCW;
}

// ============================== A/D INTERRUPT TEST ==========================
// [μ]: void
// ----------------------------------------------------------------------------
void ad_interrupt_test(void)
{
int exit_flg = 0;

	printf("===== A/D INTEERRUPT TEST ====\r\n");
	printf("- 0  : TOP menu               \r\n");
	printf("- 1-8: CH0-7 READ             \r\n");
	printf("------------------------------\r\n");

// ADC initialization 
	ADMUX = 0x00;						//   AREF
	ADCSRA = 0x8f;						// ADC Enable,ADC Clock 125.000Khz,ADC ȯ ͷƮ Ȱȭ
	SFIOR &= 0xEF;
	
	adc_int_flg = 0;					// ADCϷ ͷƮ ÷
	adc_int_ch = 0;						// ADC CH = CH0
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1') ad_start(0);// CH0 
			else if(com1_rx_data == '2') ad_start(1);// CH1 
			else if(com1_rx_data == '3') ad_start(2);// CH2 
			else if(com1_rx_data == '4') ad_start(3);// CH3 
			else if(com1_rx_data == '5') ad_start(4);// CH4 
			else if(com1_rx_data == '6') ad_start(5);// CH5 
			else if(com1_rx_data == '7') ad_start(6);// CH6 
			else if(com1_rx_data == '8') ad_start(7);// CH7 
			else putchar(com1_rx_data);	// ݼ
			// A/D  ǥ
			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("STAT ADC ");
			com1_rx_eflg = 0;
		}
		if(adc_int_flg){				// ADC  Ϸ ͷƮ ÷ 
			printf("CH%d > %d\r\n",adc_int_ch,adc_int_data);// ADC CH  ǥ
			adc_int_flg = 0;
		}
	}

// ADC initialization 
	ADMUX = 0x00;
	ADCSRA = 0x00;
	SFIOR &= 0xEF;
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: unsigned char adc_input
// ITEM1 : AD CH(0-7)
// []: A/D 10bit
// ----------------------------------------------------------------------------
void ad_start(unsigned char adc_input)
{
	adc_int_ch = adc_input;				// ADC CH 
	ADMUX = adc_input;					// ADREF(0) + CH
	ADCSRA |= 0x40;						// AD conversion 
}
